let arr = [10, 20, 30];
//> undefined
arr
//> (3) [10, 20, 30]0: 101: 202: 30length: 3[[Prototype]]: Array(0)
arr.length
//> 3
arr[1]
//> 20
[]
//> []
let b = [193, "X"];
//> undefined
b
//> (2) [193, 'X']
for (let i = 0; i < arr.length; i++) console.log(arr[i]);
//> VM317:1 10
//> VM317:1 20
//> VM317:1 30
//> undefined
for (let elem of arr) console.log(elem);
//> VM409:1 10
//> VM409:1 20
//> VM409:1 30
//> undefined
arr.push(193);
//> 4
arr
//> (4) [10, 20, 30, 193]
arr.indexOf(30);
//> 2
arr.indexOf("X");
//> -1
arr.splice(2, 1);
//> [30]
arr
//> (3) [10, 20, 193]
arr.slice(1, 2)
//> [20]

let obj = { binky: "193X", "key with spaces": 42 };
//> undefined
obj
//> {binky: '193X', key with spaces: 42}binky: "193X"key with spaces: 42[[Prototype]]: Object
obj["binky"]
//> '193X'
obj.binky
//> '193X'
obj["key with spaces"]
//> 42
delete obj.binky
//> true
obj
//> {key with spaces: 42}
arr
//> (3) [10, 20, 193]
delete arr[1] /* don't do this! */
//> true
arr
//> (3) [10, empty, 193]0: 102: 193length: 3[[Prototype]]: Array(0)
arr[1]
//> undefined
arr[1] = undefined
//> undefined
arr
//> (3) [10, undefined, 193]
arr[20]
//> undefined

obj = { binky: 5, winky: "193X" }
//> {binky: 5, winky: '193X'}
"binky" in obj
//> true
"pinky" in obj
//> false
if ("binky" in obj) /*...*/;
//> undefined
obj.pinky
//> undefined
obj.binky
//> 5
if (!obj.pinky) console.log("pinky not in obj")
//> VM1357:1 pinky not in obj
//> undefined
if (obj.pinky === undefined) console.log("pinky not in obj")
//> VM1417:1 pinky not in obj
//> undefined
Object.keys(obj)
//> (2) ['binky', 'winky']
for (let key of Object.keys(obj)) console.log(key);
//> VM1561:1 binky
//> VM1561:1 winky
//> undefined
Object.values(obj)
//> (2) [5, '193X']
Object.entries(obj)
//> (2) [Array(2), Array(2)]0: (2) ['binky', 5]1: (2) ['winky', '193X']length: 2[[Prototype]]: Array(0)
for (let [key, value] of Object.entries(obj)) console.log(key, value);
//> VM1804:1 binky 5
//> VM1804:1 winky 193X
//> undefined
for (let [key, value] of Object.entries(obj)) console.log("Key " + key + " has value " + value);
//> VM1887:1 Key binky has value 5
//> VM1887:1 Key winky has value 193X
//> undefined
for (let [key, value] of Object.entries(obj)) console.log(`Key ${key} has value ${value}`);
//> VM1941:1 Key binky has value 5
//> VM1941:1 Key winky has value 193X
//> undefined
obj.pinky = [10,20]
//> (2) [10, 20]
for (let [key, value] of Object.entries(obj)) console.log(`Key ${key} has value ${value}`);
//> VM1984:1 Key binky has value 5
//> VM1984:1 Key winky has value 193X
//> VM1984:1 Key pinky has value 10,20
//> undefined
const appendElem = (arr) => {
  arr.push(42);
};
//> undefined
arr
//> (3) [10, undefined, 193]
appendElem(arr)
//> undefined
arr
//> (4) [10, undefined, 193, 42]
